package graphical_user_interface;

import java.awt.EventQueue;

import javax.swing.JButton;
import javax.swing.JFrame;
import javax.swing.JLabel;
import javax.swing.JTextArea;
import javax.swing.JTextField;
import constants.Constants;
import protocol.*;
import file_system.*;
import multicast.*;

import java.awt.*;
import java.awt.event.*;
import java.io.File;
import java.io.IOException;
import java.security.NoSuchAlgorithmException;
import java.util.Scanner;

public class Main extends JFrame implements ActionListener{

	private static final long serialVersionUID = 1L;
	JTextField text1, text2, text3, text4, text5, text6;	
	String display_none = "";

	JButton button1 = new JButton("Change");
	JButton button2 = new JButton("Change");
	JButton button3 = new JButton("Change");
	JButton button4 = new JButton("Change");
	JButton button5 = new JButton("Change");
	JButton button6 = new JButton("Change");
	JButton button7 = new JButton("Put File");
	JButton button8 = new JButton("Get File");
	JButton button9 = new JButton("Delete File");
	JButton button10 = new JButton("Reclaim Space");
	JTextArea console = new JTextArea("CONSOLE OUTPUT");
	private Scanner ss;


	public Main(){
		init_graphics();
		Stored_files.get_stored_files();
		Files_sent.files.get_files_sent();
		make_dir_stored_files();
		make_dir_files_sent();
		Channel_1.MC();
		Stored_data_1.MDB();
		Unstored_data_1.MDR();
	}
	
	private static void make_dir_files_sent() {
		File dir = new File("files_sent");
		if (!dir.exists()){
			dir.mkdir();
		} 
	}

	private static void make_dir_stored_files() {
		File dir = new File("stored_files");
		if (!dir.exists()){
			dir.mkdir();
		} 
	}

	public void update_console(String s)
	{
		console = new JTextArea(s);
		revalidate();
		repaint();
	}

	private void init_graphics() {
		long total_space=Free_space.get_total_space();
		long usable_space=Free_space.get_usable_space();
		setTitle("SDIS_PROJECT_03");
		this.getContentPane().setLayout(new FlowLayout());

		JLabel partition = new JLabel("PARTITION DETAILS");
		JLabel unit_byte_0 = new JLabel("Bytes");
		JLabel unit_byte_1 = new JLabel("Bytes");
		JLabel unit_mega_byte_0 = new JLabel("MegaBytes");
		JLabel unit_mega_byte_1 = new JLabel("MegaBytes");
		JLabel unit_giga_byte_0 = new JLabel("GigaBytes");
		JLabel unit_giga_byte_1 = new JLabel("GigaBytes");
		JLabel total_space_0_0 = new JLabel("Total Space");
		JLabel total_space_0_1 = new JLabel("Total Space");
		JLabel total_space_0_2 = new JLabel("Total Space");
		JLabel total_space_1 = new JLabel();
		total_space_1.setText(String.valueOf(total_space));
		JLabel total_space_2 = new JLabel();
		total_space_2.setText(String.valueOf(total_space/1024 /1024));
		JLabel total_space_3 = new JLabel();
		total_space_3.setText(String.valueOf(total_space/1024 /1024 /1024));
		JLabel usable_space_0_0 = new JLabel("Usable Space");
		JLabel usable_space_0_1 = new JLabel("Usable Space");
		JLabel usable_space_0_2 = new JLabel("Usable Space");
		JLabel usable_space_1 = new JLabel();
		usable_space_1.setText(String.valueOf(usable_space));
		JLabel usable_space_2 = new JLabel();
		usable_space_2.setText(String.valueOf(usable_space/1024 /1024));
		JLabel usable_space_3 = new JLabel();
		usable_space_3.setText(String.valueOf(usable_space/1024 /1024 /1024));


		JLabel constants = new JLabel("CONSTANTS VALUES");
		JLabel header = new JLabel("Header Maximum Size");
		JLabel body = new JLabel("Body Maximum Size");
		JLabel mc = new JLabel("MC Port Value");
		JLabel mdb = new JLabel("MDB Port Value");
		JLabel mdr = new JLabel("MDR Port Value");
		JLabel version = new JLabel("Initial Version");

		partition.setBounds(710,10,200,30);

		total_space_0_0.setBounds(600,50,200,30);
		usable_space_0_0.setBounds(600,100,200,30);
		total_space_0_1.setBounds(600,150,200,30);
		usable_space_0_1.setBounds(600,200,200,30);
		total_space_0_2.setBounds(600,250,200,30);
		usable_space_0_2.setBounds(600,300,200,30);

		unit_byte_0.setBounds(850,50,100,30);
		unit_byte_1.setBounds(850,100,100,30);
		unit_mega_byte_0.setBounds(850,150,100,30);
		unit_mega_byte_1.setBounds(850,200,100,30);
		unit_giga_byte_0.setBounds(850,250,100,30);
		unit_giga_byte_1.setBounds(850,300,100,30);

		total_space_1.setBounds(720,50,100,30);
		total_space_2.setBounds(720,150,100,30);
		total_space_3.setBounds(720,250,100,30);

		usable_space_1.setBounds(720,100,100,30);
		usable_space_2.setBounds(720,200,100,30);
		usable_space_3.setBounds(720,300,100,30);

		constants.setBounds(130, 10, 200, 30);
		header.setBounds(10, 50, 190, 30);
		body.setBounds(10, 100, 190, 30);
		mc.setBounds(10, 150, 190, 30);
		mdb.setBounds(10, 200, 190, 30);
		mdr.setBounds(10, 250, 190, 30);
		version.setBounds(10, 300, 190, 30);

		text1 = new JTextField();
		text1.setText("88");
		text2 = new JTextField();
		text2.setText("64000");
		text3 = new JTextField();
		text3.setText("9000");
		text4 = new JTextField();
		text4.setText("9001");
		text5 = new JTextField();
		text5.setText("9002");
		text6 = new JTextField();
		text6.setText("1.0");

		console.setBounds(10, 800, 935, 60);

		button1.setBounds(410, 50, 100, 30);
		button2.setBounds(410, 100, 100, 30);
		button3.setBounds(410, 150, 100, 30);
		button4.setBounds(410, 200, 100, 30);
		button5.setBounds(410, 250, 100, 30);
		button6.setBounds(410, 300, 100, 30);
		button7.setBounds(10, 400, 200, 30);
		button8.setBounds(230, 400, 200, 30);
		button9.setBounds(10, 450, 200, 30);
		button10.setBounds(230, 450, 200, 30);

		text1.setBounds(200, 50, 200, 30);
		text2.setBounds(200, 100, 200, 30);
		text3.setBounds(200, 150, 200, 30);
		text4.setBounds(200, 200, 200, 30);
		text5.setBounds(200, 250, 200, 30);
		text6.setBounds(200, 300, 200, 30);

		getContentPane().setLayout(null);
		getContentPane().add(button1);
		getContentPane().add(button2);
		getContentPane().add(button3);
		getContentPane().add(button4);
		getContentPane().add(button5);
		getContentPane().add(button6);
		getContentPane().add(button7);
		getContentPane().add(button8);
		getContentPane().add(button9);
		getContentPane().add(button10);
		getContentPane().add(text1);
		getContentPane().add(text2);
		getContentPane().add(text3);
		getContentPane().add(text4);
		getContentPane().add(text5);
		getContentPane().add(text6);
		getContentPane().add(partition);
		getContentPane().add(unit_byte_0);
		getContentPane().add(unit_giga_byte_0);
		getContentPane().add(unit_mega_byte_0);
		getContentPane().add(unit_byte_1);
		getContentPane().add(unit_giga_byte_1);
		getContentPane().add(unit_mega_byte_1);
		getContentPane().add(total_space_0_0);
		getContentPane().add(total_space_0_1);
		getContentPane().add(total_space_0_2);
		getContentPane().add(total_space_1);
		getContentPane().add(total_space_2);
		getContentPane().add(total_space_3);
		getContentPane().add(usable_space_0_0);
		getContentPane().add(usable_space_0_1);
		getContentPane().add(usable_space_0_2);
		getContentPane().add(usable_space_1);
		getContentPane().add(usable_space_2);
		getContentPane().add(usable_space_3);
		getContentPane().add(constants);
		getContentPane().add(header);
		getContentPane().add(body);
		getContentPane().add(mc);
		getContentPane().add(mdb);
		getContentPane().add(mdr);
		getContentPane().add(version);
		getContentPane().add(console);



		button1.addActionListener(this);
		button2.addActionListener(this);
		button3.addActionListener(this);
		button4.addActionListener(this);
		button5.addActionListener(this);
		button6.addActionListener(this);
		button7.addActionListener(this);
		button8.addActionListener(this);
		button9.addActionListener(this);
		button10.addActionListener(this);
		//text1.addActionListener(handler);
		setSize(1600, 1200);
		setLocationRelativeTo(null);
		setDefaultCloseOperation(EXIT_ON_CLOSE);
		setVisible(true);
	}

	public void actionPerformed(ActionEvent e){
		if(button1.hasFocus())
		{
			double d = Double.parseDouble(text1.getText());
			int i=(int)d;
			Constants.set_header(i);
			update_console("Header Updated");
			System.out.println("Header Updated to "+i);
		}
		else if(button2.hasFocus())
		{
			double d = Double.parseDouble(text2.getText());
			int i=(int)d;
			Constants.set_body(i);
			update_console("Body Updated");
			System.out.println("Body Updated to "+i);
		}
		else if(button3.hasFocus())
		{
			double d = Double.parseDouble(text3.getText());
			int i=(int)d;
			Constants.set_mc(i);
			update_console("MC Port Updated");
			System.out.println("MC Port Updated to "+i);
		}
		else if(button4.hasFocus())
		{
			double d = Double.parseDouble(text4.getText());
			int i=(int)d;
			Constants.set_mdb(i);
			update_console("MDB Port Updated");
			System.out.println("MDB Port Updated to "+i);
		}
		else if(button5.hasFocus())
		{
			double d = Double.parseDouble(text5.getText());
			int i=(int)d;
			Constants.set_mdr(i);
			update_console("MDR Port Updated");
			System.out.println("MDB Port Updated to "+i);
		}
		else if(button6.hasFocus())
		{
			String s = text6.getText();
			Constants.set_version(s);
			update_console("Version Updated");
			System.out.println("Version Updated"+s);
		}
		else if(button7.hasFocus())
		{
			ss = new Scanner(System.in);
			System.out.println("Path to File: ");
			String filepath = ss.nextLine();
			File file = new File(filepath);
			System.out.println("Duplication Degree: ");
			int replication_degree = ss.nextInt();
			ss.nextLine();
			Files new_file = null;
			try {
				new_file = Files.create_file(file,replication_degree);
			} catch (NoSuchAlgorithmException | IOException e1) {
				e1.printStackTrace();
			}
			File_attributes descriptor = new File_attributes(new_file.get_file_id(), filepath);
			Files_sent.files.add_sent_file(descriptor);
			Protocol.get_protocol().put_chunk(new_file,replication_degree);
		}
		else if(button8.hasFocus())
		{
			ss = new Scanner(System.in);
			for(int i=0;i < Files_sent.files.get_files_sent().size(); i++)
			{
				System.out.println((i+1) + " - " + Files_sent.files.get_files_sent().get(i).get_file_path());
			}
			System.out.println("0 - Exit");
			int i = ss.nextInt();
			ss.nextLine();
			if( i == 0)
			{
				return;
			}
			if( i > Files_sent.files.get_files_sent().size() )
			{
				System.out.println("No such index");
				return;
			}
			Protocol.get_protocol().get_file(Files_sent.files.get_files_sent().get(i-1).get_file_id());
		}
		else if(button9.hasFocus())
		{
			ss = new Scanner(System.in);
			for(int i=0;i < Files_sent.files.get_files_sent().size(); i++)
				System.out.println((i+1) + " - " + Files_sent.files.get_files_sent().get(i).get_file_path());
			System.out.println("0 - Exit");
			int i = ss.nextInt();
			ss.nextLine();
			if( i == 0)
			{
				return;
			}
			if( i > Files_sent.files.get_files_sent().size() ){
				System.out.println("No such index");
				return;
			}
			Protocol.get_protocol().delete_file(Files_sent.files.get_files_sent().get(i-1).get_file_id());
			Files_sent.files.delete_sent_file(Files_sent.files.get_files_sent().get(i-1));
		}
		else if(button10.hasFocus())
		{
			Protocol.get_protocol().free_space();
		}
	}

	public static void main(String[] args) {
		EventQueue.invokeLater(new Runnable() {

			@Override
			public void run() {
				Main program = null;
				program = new Main();
				program.setVisible(true);
			}
		});
	}
}
