package protocol;

import java.io.IOException;
import java.net.DatagramPacket;
import java.net.DatagramSocket;
import java.net.InetAddress;
import java.net.SocketException;
import java.util.Random;

import file_system.*;
import constants.Constants;
import exceptions.*;

public class Chunk_dispatcher_2 extends Thread{
	private String packet;
	private boolean temp_1;

	public Chunk_dispatcher_2(String packet){
		this.packet = packet;
		temp_1 = false;
	}

	public Chunk_dispatcher_2(String packet, boolean temp_1){
		this.packet = packet;
		this.temp_1 = temp_1;
	}

	public void run(){
		String[] packet_temp = packet.split(Constants.CRLF());
		String[] head = packet_temp[0].split(" ");
		String file_id = head[2];
		int chunk_number = Integer.parseInt(head[3]);
		String message_type = head[0];
		String version = head[1];
		if(message_type.equalsIgnoreCase("GETCHUNK") && !temp_1){
			try {
				get_process(file_id, chunk_number,version);
			}
			catch (No_such_chunk | IOException e) {

			}
		}else if(message_type.equalsIgnoreCase("GETCHUNK") && temp_1){
			try {
				send_get(file_id,chunk_number);
			}
			catch (Can_not_get_chunk e) {
				e.printStackTrace();
				return;
			}
		}
		else if(message_type.equalsIgnoreCase("CHUNK")){
			String data = "";
			if( packet_temp.length >= 3)
			{
				data = packet_temp[2];
				for( int i= 3; i<packet_temp.length;i++)
				{
					data = data + Constants.CRLF() + packet_temp[i];
				}
			}
			process_chunk(file_id, chunk_number, data,version);
		}
		else if( message_type.equalsIgnoreCase("GETFILE") )
		{
			get_file(file_id);
		}
	}

	private synchronized void process_chunk(String file_id, int chunk_number, String data, String version) {
		Chunk chunk = Restore_chunk.get_current_chunk(file_id, chunk_number);
		if( chunk != null )
		{
			Restore_chunk.delete_current_chunk(chunk);
		}
		if( Restore_chunk.delete_temp_chunk(file_id, chunk_number))
		{
			try {
				String body[] = data.split(" ");
				byte[] message = new byte[3];
				InetAddress address = InetAddress.getByName(body[0]);
				DatagramSocket socket = new DatagramSocket(Constants.MC_PORT);
				DatagramPacket packet_temp = new DatagramPacket(message,message.length,address, Integer.parseInt(body[1]));
				socket.send(packet_temp);
				byte[] received_data = new byte[Constants.BODY_MAX_SIZE];
				DatagramPacket received = new DatagramPacket(received_data,received_data.length);
				socket.receive(received);
				String data_temp = new String(received_data);
				data_temp.trim();
				Stored_files.get_stored_files().get_file(file_id).add_chunk(new Chunk(file_id,chunk_number,data_temp,0));
			} catch (IOException e) {
				System.out.println("Error receiving data");
			}
			synchronized(Restore_chunk.temp_object)
			{
				Restore_chunk.temp_object.notifyAll();
			}
		}
	}

	private void get_process(String file_id, int chunk_number, String version) throws No_such_chunk, IOException {
		Chunk chunk = Stored_files.get_stored_files().get_file(file_id).get_chunk(chunk_number);
		if(chunk == null)
		{
			throw new No_such_chunk();
		}
		Restore_chunk.add_current_chunk(chunk);
		Random random = new Random();
		synchronized(this)
		{
			try {
				wait(random.nextInt(400));
			} catch (InterruptedException e) {
				e.printStackTrace();
				return;
			}
		}
		chunk = Restore_chunk.get_current_chunk(file_id, chunk_number);
		Restore_chunk.send_chunk(file_id, chunk_number, chunk.get_data());
		DatagramSocket socket = new DatagramSocket();
		String address = socket.getLocalAddress().getCanonicalHostName() + " " + socket.getPort();
		Restore_chunk.send_chunk(file_id, chunk_number, address);
		byte[] temp = new byte[3];
		DatagramPacket p = new DatagramPacket(temp,temp.length);
		DatagramPacket send = new DatagramPacket(chunk.get_data().getBytes(),chunk.get_data().getBytes().length,p.getAddress(),p.getPort());
		socket.send(send);
	}

	private void send_get(String file_id, int chunk_number) throws Can_not_get_chunk
	{
		Restore_chunk.add_temp_chunk(file_id, chunk_number);
		Restore_chunk.get_chunk(file_id, chunk_number);
		int i=0;
		synchronized(Restore_chunk.temp_object)
		{
			while( Restore_chunk.verify_temp_chunk(file_id, chunk_number) && i < 4 )
			{
				try {
					Restore_chunk.temp_object.wait(400);
				} catch (InterruptedException e) {
				}
				i++;
			}
		}
		if( i == 4 )
		{
			throw new Can_not_get_chunk();
		}
	}

	private void get_file(String file_id)
	{      
		int chunk_number = 0;
		try {
			send_get(file_id,chunk_number);
		} catch (Can_not_get_chunk e) {
			e.printStackTrace();
			return;
		}

		Chunk chunk = Stored_files.get_stored_files().get_file(file_id).get_chunk(chunk_number);
		while( chunk != null && chunk.get_data().length() == Constants.BODY_MAX_SIZE)
		{
			chunk_number++;
			try {
				send_get(file_id,chunk_number);
			} catch (Can_not_get_chunk e) {
				e.printStackTrace();
				return;
			}
			chunk = Stored_files.get_stored_files().get_file(file_id).get_chunk(chunk_number);
		}
		Stored_files.get_stored_files().get_file(file_id).save_file(file_id);
		Stored_files.get_stored_files().get_file(file_id);
	}
}