package protocol;

import file_system.*;

public class Protocol{

	private static Protocol protocol = new Protocol();
	private static Save_chunk save_chunk;
	private static Delete_file delete_file;
	private static Restore_chunk restore_chunk;
	private static Reclaim_space_1 reclaim_space;

	private Protocol()
	{
		Protocol.save_chunk = new Save_chunk();
		Protocol.delete_file = new Delete_file();
		Protocol.restore_chunk = new Restore_chunk();
		Protocol.reclaim_space = new Reclaim_space_1();
	}

	public static Protocol get_protocol()
	{
		return protocol;
	}

	public static void send_chunk(Chunk chunk)
	{
		save_chunk.send_chunk(chunk);
	}

	public void process(String packet) {
		String head[] = packet.split(" ");
		String messageType = head[0];

		if( messageType.equalsIgnoreCase("PUTCHUNK") || messageType.equalsIgnoreCase("STORED")) 
		{
			Save_chunk.process_chunk(packet);
		}
		else if( messageType.equalsIgnoreCase("DELETE")) 
		{
			Delete_file.process(packet);
		}
		else if( messageType.equalsIgnoreCase("GETCHUNK") || messageType.equalsIgnoreCase("CHUNK"))
		{
			Restore_chunk.process(packet);
		}
		else if( messageType.equalsIgnoreCase("REMOVED"))
		{
			Reclaim_space_1.process(packet);
		}
	}

	public void put_chunk(Files new_file, int duplication_degree) {
		Save_chunk.send_file(new_file, duplication_degree);
	}

	public void delete_file(String file_id) {
		Delete_file.send_packet(file_id);               
	}

	public void get_file(String file_id) { 
		Restore_chunk.get_file(file_id);
	}

	public void free_space() {
		Reclaim_space_1.free_space();
	}
}