package protocol;

import java.util.ArrayList;

import multicast.*;

import constants.Constants;
import file_system.*;

public class Reclaim_space_1 {
	private static ArrayList<Chunk> current_chunks;

	public Reclaim_space_1()
	{
		current_chunks = new ArrayList<Chunk>();
	}

	public static void check_chunk(Chunk chunk)
	{
		if( chunk_already_in(chunk))
		{
			current_chunks.remove(chunk);
		}
	}

	public static void add_chunk(Chunk chunk)
	{
		check_chunk(chunk);
		current_chunks.add(chunk);
	}

	public static boolean chunk_already_in(Chunk chunk)
	{
		return current_chunks.contains(chunk);
	}

	public static int get_total_size()
	{
		return current_chunks.size();
	}

	public static void process(String packet)
	{
		String body[] = packet.split(Constants.CRLF());
		String head = body[0];
		String head_temp[] = head.split(" ");
		String file_id = head_temp[2];
		int chunk_number = Integer.parseInt(head_temp[3]);
		Reclaim_space_2 reclaim = new Reclaim_space_2(file_id,chunk_number);
		reclaim.start();
	}

	public void send_removed_chunk(Chunk chunk)
	{
		String packet = "REMOVED "+ Constants.INITIAL_VERSION + " " + chunk.get_file_id() + " " + chunk.get_chunk_number() + Constants.CRLF() + Constants.CRLF();
		Channel_1.MC().send(packet);
	}

	public static void free_space()
	{
		Reclaim_space_2 reclaim = new Reclaim_space_2();
		reclaim.start();
	}
}