package protocol;

import java.util.ArrayList;

import file_system.*;
import multicast.*;
import constants.Constants;

public class Save_chunk {
	public static ArrayList<Chunk> current_chunks;

	public static Chunk get_current_chunk(String file_id, int chunk_number)
	{
		for( int i=0; i < current_chunks.size(); i++)
		{
			if( current_chunks.get(i).get_file_id().equals(file_id) && current_chunks.get(i).get_chunk_number() == chunk_number)
				return current_chunks.get(i);
		}
		return null;
	}

	public static void delete_current_chunk(String file_id, int chunk_number) {

		for( int i=0; i < current_chunks.size(); i++)
		{
			if( current_chunks.get(i).get_file_id().equals(file_id) && current_chunks.get(i).get_chunk_number() == chunk_number)
			{
				current_chunks.remove(i);
				return;
			}
		}
	}

	public Save_chunk()
	{
		current_chunks = new ArrayList<Chunk>();
	}

	public static void process_chunk(String packet){                
		Chunk_dispatcher_1 dispatcher = new Chunk_dispatcher_1(packet);
		dispatcher.run();    
	}

	public static void send_chunk(String file_id, int chunk_number) {
		String packet = "STORED " + Constants.INITIAL_VERSION + " " + file_id + " " + chunk_number + Constants.CRLF()+Constants.CRLF();
		Channel_1.MC().send(packet);
	}

	public static String get_putchunk_packet(Chunk chunk)
	{
		String packet = "PUTCHUNK "+ Constants.INITIAL_VERSION + " " + chunk.get_file_id() + " " + chunk.get_chunk_number() + " " + ((Integer)chunk.get_duplication_degree()).toString() + Constants.CRLF() + Constants.CRLF() + chunk.get_data();
		return packet;
	}

	public void send_chunk(Chunk chunk)
	{
		String packet = get_putchunk_packet(chunk);
		if(get_current_chunk(chunk.get_file_id(), chunk.get_chunk_number()) == null)
		{
			current_chunks.add(chunk);
		}
		Chunk_dispatcher_1 dispatcher = new Chunk_dispatcher_1(packet,true);
		dispatcher.run();
	}

	public static void send_file(Files file, int duplication_degree)
	{
		String packet = "PUTFILE "+ Constants.INITIAL_VERSION + " " + file.get_file_id() + " 0 " + duplication_degree + Constants.CRLF() + Constants.CRLF();
		Stored_files.get_stored_files().add_file(file);
		Chunk_dispatcher_1 dispatcher = new Chunk_dispatcher_1(packet,true);
		dispatcher.run();

	}
}